/* This file was generated by SableCC (http://www.sablecc.org/). */

package grammar3_32.lexer;

import java.io.*;
import java.util.*;
import grammar3_32.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.INITIAL;

    private PushbackReader in;
    private int line;
    private int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuffer text = new StringBuffer();

    protected void filter() throws LexerException, IOException
    {
    }

    public Lexer(PushbackReader in)
    {
        this.in = in;

        if(gotoTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Lexer.class.getResourceAsStream("lexer.dat")));

                // read gotoTable
                int length = s.readInt();
                gotoTable = new int[length][][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][][];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        length = s.readInt();
                        gotoTable[i][j] = new int[length][3];
                        for(int k = 0; k < gotoTable[i][j].length; k++)
                        {
                            for(int l = 0; l < 3; l++)
                            {
                                gotoTable[i][j][k][l] = s.readInt();
                            }
                        }
                    }
                }

                // read accept
                length = s.readInt();
                accept = new int[length][];
                for(int i = 0; i < accept.length; i++)
                {
                    length = s.readInt();
                    accept[i] = new int[length];
                    for(int j = 0; j < accept[i].length; j++)
                    {
                        accept[i][j] = s.readInt();
                    }
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.");
            }
        }
    }

    public Token peek() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfa_state = 0;

        int start_pos = pos;
        int start_line = line;

        int accept_state = -1;
        int accept_token = -1;
        int accept_length = -1;
        int accept_pos = -1;
        int accept_line = -1;

        int[][][] gotoTable = this.gotoTable[state.id()];
        int[] accept = this.accept[state.id()];
        text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                case 10:
                    if(cr)
                    {
                        cr = false;
                    }
                    else
                    {
                        line++;
                        pos = 0;
                    }
                    break;
                case 13:
                    line++;
                    pos = 0;
                    cr = true;
                    break;
                default:
                    pos++;
                    cr = false;
                    break;
                };

                text.append((char) c);

                do
                {
                    int oldState = (dfa_state < -1) ? (-2 -dfa_state) : dfa_state;

                    dfa_state = -1;

                    int[][] tmp1 =  gotoTable[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    while(low <= high)
                    {
                        int middle = (low + high) / 2;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfa_state = tmp2[2];
                            break;
                        }
                    }
                }while(dfa_state < -1);
            }
            else
            {
                dfa_state = -1;
            }

            if(dfa_state >= 0)
            {
                if(accept[dfa_state] != -1)
                {
                    accept_state = dfa_state;
                    accept_token = accept[dfa_state];
                    accept_length = text.length();
                    accept_pos = pos;
                    accept_line = line;
                }
            }
            else
            {
                if(accept_state != -1)
                {
                    switch(accept_token)
                    {
                    case 0:
                        {
                            Token token = new0(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 1:
                        {
                            Token token = new1(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 2:
                        {
                            Token token = new2(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 3:
                        {
                            Token token = new3(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 4:
                        {
                            Token token = new4(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 5:
                        {
                            Token token = new5(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 6:
                        {
                            Token token = new6(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 7:
                        {
                            Token token = new7(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 8:
                        {
                            Token token = new8(
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 9:
                        {
                            Token token = new9(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    case 10:
                        {
                            Token token = new10(
                                getText(accept_length),
                                start_line + 1,
                                start_pos + 1);
                            pushBack(accept_length);
                            pos = accept_pos;
                            line = accept_line;
                            return token;
                        }
                    }
                }
                else
                {
                    if(text.length() > 0)
                    {
                        throw new LexerException(
                            "[" + (start_line + 1) + "," + (start_pos + 1) + "]" +
                            " Unknown token: " + text);
                    }
                    else
                    {
                        EOF token = new EOF(
                            start_line + 1,
                            start_pos + 1);
                        return token;
                    }
                }
            }
        }
    }

    Token new0(int line, int pos) { return new TWhile(line, pos); }
    Token new1(int line, int pos) { return new TBegin(line, pos); }
    Token new2(int line, int pos) { return new TEnd(line, pos); }
    Token new3(int line, int pos) { return new TDo(line, pos); }
    Token new4(int line, int pos) { return new TIf(line, pos); }
    Token new5(int line, int pos) { return new TThen(line, pos); }
    Token new6(int line, int pos) { return new TElse(line, pos); }
    Token new7(int line, int pos) { return new TSemi(line, pos); }
    Token new8(int line, int pos) { return new TAssign(line, pos); }
    Token new9(String text, int line, int pos) { return new TWhitespace(text, line, pos); }
    Token new10(String text, int line, int pos) { return new TId(text, line, pos); }

    private int getChar() throws IOException
    {
        if(eof)
        {
            return -1;
        }

        int result = in.read();

        if(result == -1)
        {
            eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }
    }

    protected void unread(Token token) throws IOException
    {
        String text = token.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            eof = false;

            in.unread(text.charAt(i));
        }

        pos = token.getPos() - 1;
        line = token.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        StringBuffer s = new StringBuffer(acceptLength);
        for(int i = 0; i < acceptLength; i++)
        {
            s.append(text.charAt(i));
        }

        return s.toString();
    }

    private static int[][][][] gotoTable;
/*  {
        { // INITIAL
            {{32, 32, 1}, {59, 59, 2}, {61, 61, 3}, {92, 92, 4}, {97, 97, 5}, {98, 98, 6}, {99, 99, 5}, {100, 100, 7}, {101, 101, 8}, {102, 104, 5}, {105, 105, 9}, {106, 115, 5}, {116, 116, 10}, {117, 118, 5}, {119, 119, 11}, {120, 122, 5}, },
            {{32, 32, 1}, {92, 92, 4}, },
            {},
            {},
            {{110, 110, 12}, {116, 116, 13}, },
            {{48, 57, 14}, {97, 122, 15}, },
            {{48, 57, 14}, {97, 100, 15}, {101, 101, 16}, {102, 122, 15}, },
            {{48, 57, 14}, {97, 110, 15}, {111, 111, 17}, {112, 122, 15}, },
            {{48, 57, 14}, {97, 107, 15}, {108, 108, 18}, {109, 109, 15}, {110, 110, 19}, {111, 122, 15}, },
            {{48, 57, 14}, {97, 101, 15}, {102, 102, 20}, {103, 122, 15}, },
            {{48, 57, 14}, {97, 103, 15}, {104, 104, 21}, {105, 122, 15}, },
            {{48, 103, -12}, {104, 104, 22}, {105, 122, 15}, },
            {{32, 92, -3}, },
            {{32, 92, -3}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 57, 14}, {97, 102, 15}, {103, 103, 23}, {104, 122, 15}, },
            {{48, 122, -7}, },
            {{48, 57, 14}, {97, 114, 15}, {115, 115, 24}, {116, 122, 15}, },
            {{48, 57, 14}, {97, 99, 15}, {100, 100, 25}, {101, 122, 15}, },
            {{48, 122, -7}, },
            {{48, 100, -8}, {101, 101, 26}, {102, 122, 15}, },
            {{48, 57, 14}, {97, 104, 15}, {105, 105, 27}, {106, 122, 15}, },
            {{48, 104, -24}, {105, 105, 28}, {106, 122, 15}, },
            {{48, 100, -8}, {101, 101, 29}, {102, 122, 15}, },
            {{48, 122, -7}, },
            {{48, 57, 14}, {97, 109, 15}, {110, 110, 30}, {111, 122, 15}, },
            {{48, 107, -10}, {108, 108, 31}, {109, 122, 15}, },
            {{48, 109, -28}, {110, 110, 32}, {111, 122, 15}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
            {{48, 100, -8}, {101, 101, 33}, {102, 122, 15}, },
            {{48, 122, -7}, },
            {{48, 122, -7}, },
        }
    };*/

    private static int[][] accept;
/*  {
        // INITIAL
        {-1, 9, 7, 8, -1, 10, 10, 10, 10, 10, 10, 10, 9, 9, 10, 10, 10, 3, 10, 10, 4, 10, 10, 10, 10, 2, 10, 10, 10, 6, 5, 10, 1, 0, },

    };*/

    public static class State
    {
        public final static State INITIAL = new State(0);

        private int id;

        private State(int id)
        {
            this.id = id;
        }

        public int id()
        {
            return id;
        }
    }
}
