/* This file was generated by SableCC (http://www.sablecc.org/). */

package calculator.parser;

import calculator.lexer.*;
import calculator.node.*;
import calculator.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(0), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(1), node, true); } break;
                    case 3: { Node node = new3(); push(goTo(1), node, true); } break;
                    case 4: { Node node = new4(); push(goTo(2), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(2), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(2), node, true); } break;
                    case 7: { Node node = new7(); push(goTo(3), node, true); } break;
                    case 8: { Node node = new8(); push(goTo(3), node, true); } break;
                    case 9: { Node node = new9(); push(goTo(3), node, true); } break;
                    case 10: { Node node = new10(); push(goTo(4), node, true); } break;
                    case 11: { Node node = new11(); push(goTo(4), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PStatements node1 = (PStatements) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PStatements node2 = (PStatements) pop();
        PStmt node1 = (PStmt) pop();
        ASingleStatements node = new ASingleStatements(node1, node2);
        return node;
    }

    Node new1()
    {
        PStmt node1 = (PStmt) pop();
        AMultiStatements node = new AMultiStatements(node1);
        return node;
    }

    Node new2()
    {
        TSemicolon node3 = (TSemicolon) pop();
        PExpr node2 = (PExpr) pop();
        TPrint node1 = (TPrint) pop();
        AExprStmt node = new AExprStmt(node1, node2, node3);
        return node;
    }

    Node new3()
    {
        TSemicolon node4 = (TSemicolon) pop();
        PExpr node3 = (PExpr) pop();
        TEqual node2 = (TEqual) pop();
        TId node1 = (TId) pop();
        AAssignStmt node = new AAssignStmt(node1, node2, node3, node4);
        return node;
    }

    Node new4()
    {
        PTerm node3 = (PTerm) pop();
        TPlus node2 = (TPlus) pop();
        PExpr node1 = (PExpr) pop();
        APlusExpr node = new APlusExpr(node1, node2, node3);
        return node;
    }

    Node new5()
    {
        PTerm node3 = (PTerm) pop();
        TMinus node2 = (TMinus) pop();
        PExpr node1 = (PExpr) pop();
        AMinusExpr node = new AMinusExpr(node1, node2, node3);
        return node;
    }

    Node new6()
    {
        PTerm node1 = (PTerm) pop();
        ATerExpr node = new ATerExpr(node1);
        return node;
    }

    Node new7()
    {
        PFactor node3 = (PFactor) pop();
        TTimes node2 = (TTimes) pop();
        PTerm node1 = (PTerm) pop();
        AMultTerm node = new AMultTerm(node1, node2, node3);
        return node;
    }

    Node new8()
    {
        PFactor node3 = (PFactor) pop();
        TDiv node2 = (TDiv) pop();
        PTerm node1 = (PTerm) pop();
        ADivTerm node = new ADivTerm(node1, node2, node3);
        return node;
    }

    Node new9()
    {
        PFactor node1 = (PFactor) pop();
        AFacTerm node = new AFacTerm(node1);
        return node;
    }

    Node new10()
    {
        TNumber node1 = (TNumber) pop();
        ANumFactor node = new ANumFactor(node1);
        return node;
    }

    Node new11()
    {
        TId node1 = (TId) pop();
        AIdFactor node = new AIdFactor(node1);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {6, SHIFT, 1}, {8, SHIFT, 2}, },
			{{-1, ERROR, 1}, {7, SHIFT, 5}, {8, SHIFT, 6}, },
			{{-1, ERROR, 2}, {4, SHIFT, 10}, },
			{{-1, ERROR, 3}, {9, ACCEPT, -1}, },
			{{-1, REDUCE, 1}, {6, SHIFT, 1}, {8, SHIFT, 2}, },
			{{-1, REDUCE, 10}, },
			{{-1, REDUCE, 11}, },
			{{-1, ERROR, 7}, {0, SHIFT, 12}, {1, SHIFT, 13}, {5, SHIFT, 14}, },
			{{-1, REDUCE, 6}, {2, SHIFT, 15}, {3, SHIFT, 16}, },
			{{-1, REDUCE, 9}, },
			{{-1, ERROR, 10}, {7, SHIFT, 5}, {8, SHIFT, 6}, },
			{{-1, REDUCE, 0}, },
			{{-1, ERROR, 12}, {7, SHIFT, 5}, {8, SHIFT, 6}, },
			{{-1, ERROR, 13}, {7, SHIFT, 5}, {8, SHIFT, 6}, },
			{{-1, REDUCE, 2}, },
			{{-1, ERROR, 15}, {7, SHIFT, 5}, {8, SHIFT, 6}, },
			{{-1, ERROR, 16}, {7, SHIFT, 5}, {8, SHIFT, 6}, },
			{{-1, ERROR, 17}, {0, SHIFT, 12}, {1, SHIFT, 13}, {5, SHIFT, 22}, },
			{{-1, REDUCE, 4}, {2, SHIFT, 15}, {3, SHIFT, 16}, },
			{{-1, REDUCE, 5}, {2, SHIFT, 15}, {3, SHIFT, 16}, },
			{{-1, REDUCE, 8}, },
			{{-1, REDUCE, 7}, },
			{{-1, REDUCE, 3}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 3}, {4, 11}, },
			{{-1, 4}, },
			{{-1, 7}, {10, 17}, },
			{{-1, 8}, {12, 18}, {13, 19}, },
			{{-1, 9}, {15, 20}, {16, 21}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'print', id",
			"expecting: number, id",
			"expecting: '='",
			"expecting: EOF",
			"expecting: 'print', id, EOF",
			"expecting: '+', '-', '/', '*', ';'",
			"expecting: '+', '-', ';'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 2, 3, 4, 5, 5, 6, 5, 5, 1, 3, 1, 1, 4, 1, 1, 6, 5, 5, 5, 5, 4, 
        };*/
}
