/* This file was generated by SableCC (http://www.sablecc.org/). */

package grammar3_32.parser;

import grammar3_32.lexer.*;
import grammar3_32.node.*;
import grammar3_32.analysis.*;
import java.util.*;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.IOException;

public class Parser
{
    public final Analysis ignoredTokens = new AnalysisAdapter();

    protected Node node;

    private final Lexer lexer;
    private final ListIterator stack = new LinkedList().listIterator();
    private int last_shift;
    private int last_pos;
    private int last_line;
    private Token last_token;
    private final TokenIndex converter = new TokenIndex();
    private final int[] action = new int[2];

    private final static int SHIFT = 0;
    private final static int REDUCE = 1;
    private final static int ACCEPT = 2;
    private final static int ERROR = 3;

    protected void filter() throws ParserException, LexerException, IOException
    {
    }

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;

        if(actionTable == null)
        {
            try
            {
                DataInputStream s = new DataInputStream(
                    new BufferedInputStream(
                    Parser.class.getResourceAsStream("parser.dat")));

                // read actionTable
                int length = s.readInt();
                actionTable = new int[length][][];
                for(int i = 0; i < actionTable.length; i++)
                {
                    length = s.readInt();
                    actionTable[i] = new int[length][3];
                    for(int j = 0; j < actionTable[i].length; j++)
                    {
                        for(int k = 0; k < 3; k++)
                        {
                            actionTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read gotoTable
                length = s.readInt();
                gotoTable = new int[length][][];
                for(int i = 0; i < gotoTable.length; i++)
                {
                    length = s.readInt();
                    gotoTable[i] = new int[length][2];
                    for(int j = 0; j < gotoTable[i].length; j++)
                    {
                        for(int k = 0; k < 2; k++)
                        {
                            gotoTable[i][j][k] = s.readInt();
                        }
                    }
                }

                // read errorMessages
                length = s.readInt();
                errorMessages = new String[length];
                for(int i = 0; i < errorMessages.length; i++)
                {
                    length = s.readInt();
                    StringBuffer buffer = new StringBuffer();

                    for(int j = 0; j < length; j++)
                    {
                        buffer.append(s.readChar());
                    }
                    errorMessages[i] = buffer.toString();
                }

                // read errors
                length = s.readInt();
                errors = new int[length];
                for(int i = 0; i < errors.length; i++)
                {
                    errors[i] = s.readInt();
                }

                s.close();
            }
            catch(Exception e)
            {
                throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.");
            }
        }
    }

    private int goTo(int index)
    {
        int state = state();
        int low = 1;
        int high = gotoTable[index].length - 1;
        int value = gotoTable[index][0][1];

        while(low <= high)
        {
            int middle = (low + high) / 2;

            if(state < gotoTable[index][middle][0])
            {
                high = middle - 1;
            }
            else if(state > gotoTable[index][middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = gotoTable[index][middle][1];
                break;
            }
        }

        return value;
    }

    private void push(int state, Node node, boolean filter) throws ParserException, LexerException, IOException
    {
        this.node = node;

        if(filter)
        {
            filter();
        }

        if(!stack.hasNext())
        {
            stack.add(new State(state, this.node));
            return;
        }

        State s = (State) stack.next();
        s.state = state;
        s.node = this.node;
    }

    private int state()
    {
        State s = (State) stack.previous();
        stack.next();
        return s.state;
    }

    private Node pop()
    {
        return (Node) ((State) stack.previous()).node;
    }

    private int index(Switchable token)
    {
        converter.index = -1;
        token.apply(converter);
        return converter.index;
    }

    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null, false);

        List ign = null;
        while(true)
        {
            while(index(lexer.peek()) == -1)
            {
                if(ign == null)
                {
                    ign = new TypedLinkedList(NodeCast.instance);
                }

                ign.add(lexer.next());
            }

            if(ign != null)
            {
                ignoredTokens.setIn(lexer.peek(), ign);
                ign = null;
            }

            last_pos = lexer.peek().getPos();
            last_line = lexer.peek().getLine();
            last_token = lexer.peek();

            int index = index(lexer.peek());
            action[0] = actionTable[state()][0][1];
            action[1] = actionTable[state()][0][2];

            int low = 1;
            int high = actionTable[state()].length - 1;

            while(low <= high)
            {
                int middle = (low + high) / 2;

                if(index < actionTable[state()][middle][0])
                {
                    high = middle - 1;
                }
                else if(index > actionTable[state()][middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action[0] = actionTable[state()][middle][1];
                    action[1] = actionTable[state()][middle][2];
                    break;
                }
            }

            switch(action[0])
            {
                case SHIFT:
                    push(action[1], lexer.next(), true);
                    last_shift = action[1];
                    break;
                case REDUCE:
                    switch(action[1])
                    {
                    case 0: { Node node = new0(); push(goTo(0), node, true); } break;
                    case 1: { Node node = new1(); push(goTo(1), node, true); } break;
                    case 2: { Node node = new2(); push(goTo(1), node, true); } break;
                    case 3: { Node node = new3(); push(goTo(1), node, true); } break;
                    case 4: { Node node = new4(); push(goTo(1), node, true); } break;
                    case 5: { Node node = new5(); push(goTo(2), node, true); } break;
                    case 6: { Node node = new6(); push(goTo(2), node, true); } break;
                    }
                    break;
                case ACCEPT:
                    {
                        EOF node2 = (EOF) lexer.next();
                        PProg node1 = (PProg) pop();
                        Start node = new Start(node1, node2);
                        return node;
                    }
                case ERROR:
                    throw new ParserException(last_token,
                        "[" + last_line + "," + last_pos + "] " +
                        errorMessages[errors[action[1]]]);
            }
        }
    }

    Node new0()
    {
        PStmlist node1 = (PStmlist) pop();
        AProg node = new AProg(node1);
        return node;
    }

    Node new1()
    {
        TId node3 = (TId) pop();
        TAssign node2 = (TAssign) pop();
        TId node1 = (TId) pop();
        AAssStm node = new AAssStm(node1, node2, node3);
        return node;
    }

    Node new2()
    {
        PStm node4 = (PStm) pop();
        TDo node3 = (TDo) pop();
        TId node2 = (TId) pop();
        TWhile node1 = (TWhile) pop();
        AWhileStm node = new AWhileStm(node1, node2, node3, node4);
        return node;
    }

    Node new3()
    {
        TEnd node3 = (TEnd) pop();
        PStmlist node2 = (PStmlist) pop();
        TBegin node1 = (TBegin) pop();
        ABeginStm node = new ABeginStm(node1, node2, node3);
        return node;
    }

    Node new4()
    {
        PStm node4 = (PStm) pop();
        TThen node3 = (TThen) pop();
        TId node2 = (TId) pop();
        TIf node1 = (TIf) pop();
        AIfThenStm node = new AIfThenStm(node1, node2, node3, node4);
        return node;
    }

    Node new5()
    {
        PStm node1 = (PStm) pop();
        AStmtStmlist node = new AStmtStmlist(node1);
        return node;
    }

    Node new6()
    {
        TSemi node2 = (TSemi) pop();
        PStmlist node1 = (PStmlist) pop();
        AStmtlistStmlist node = new AStmtlistStmlist(node1, node2);
        return node;
    }

    private static int[][][] actionTable;
/*      {
			{{-1, ERROR, 0}, {0, SHIFT, 1}, {1, SHIFT, 2}, {4, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, ERROR, 1}, {9, SHIFT, 8}, },
			{{-1, ERROR, 2}, {0, SHIFT, 1}, {1, SHIFT, 2}, {4, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, ERROR, 3}, {9, SHIFT, 10}, },
			{{-1, ERROR, 4}, {8, SHIFT, 11}, },
			{{-1, ERROR, 5}, {10, ACCEPT, -1}, },
			{{-1, REDUCE, 5}, },
			{{-1, REDUCE, 0}, {7, SHIFT, 12}, },
			{{-1, ERROR, 8}, {3, SHIFT, 13}, },
			{{-1, ERROR, 9}, {2, SHIFT, 14}, {7, SHIFT, 12}, },
			{{-1, ERROR, 10}, {5, SHIFT, 15}, },
			{{-1, ERROR, 11}, {9, SHIFT, 16}, },
			{{-1, REDUCE, 6}, },
			{{-1, ERROR, 13}, {0, SHIFT, 1}, {1, SHIFT, 2}, {4, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, REDUCE, 3}, },
			{{-1, ERROR, 15}, {0, SHIFT, 1}, {1, SHIFT, 2}, {4, SHIFT, 3}, {9, SHIFT, 4}, },
			{{-1, REDUCE, 1}, },
			{{-1, REDUCE, 2}, },
			{{-1, REDUCE, 4}, },
        };*/
    private static int[][][] gotoTable;
/*      {
			{{-1, 5}, },
			{{-1, 6}, {13, 17}, {15, 18}, },
			{{-1, 7}, {2, 9}, },
        };*/
    private static String[] errorMessages;
/*      {
			"expecting: 'while', 'begin', 'if', id",
			"expecting: id",
			"expecting: '='",
			"expecting: EOF",
			"expecting: 'end', ';', EOF",
			"expecting: ';', EOF",
			"expecting: 'do'",
			"expecting: 'end', ';'",
			"expecting: 'then'",
        };*/
    private static int[] errors;
/*      {
			0, 1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 1, 4, 0, 4, 0, 4, 4, 4, 
        };*/
}
